package cn.oyohotels.utils

import java.util
import com.alibaba.dcm.DnsCacheManipulator
import org.apache.hadoop.hbase.client.Delete
import org.apache.hadoop.hbase._
import org.apache.hadoop.hbase.client._
import org.apache.hadoop.hbase.io.ImmutableBytesWritable
import org.apache.hadoop.hbase.mapreduce.{TableInputFormat, TableMapReduceUtil, TableOutputFormat}
import org.apache.hadoop.hbase.util.Bytes
import org.apache.hadoop.mapreduce.Job
import org.apache.spark.rdd.RDD
import org.apache.spark.sql.{DataFrame, Row, SparkSession}
import org.slf4j.LoggerFactory


object HbaseUtil {
  final val FAMILY_NAME = "F"
  final val RT_NS = "default"
  private val logger = LoggerFactory.getLogger(this.getClass)

  val lrs = HbaseUtil.getClass.getResource("/").getPath

  lazy val conf = {
    val myConf = HBaseConfiguration.create()
    myConf.set("hbase.zookeeper.property.clientPort", "2181")
    myConf.set("hbase.zookeeper.quorum", "hb-proxy-pub-uf6as8i6h85k02092-001.hbase.rds.aliyuncs.com")
    DnsCacheManipulator.setDnsCache("hb-uf6as8i6h85k02092-001.hbase.rds.aliyuncs.com", "47.101.251.157")
    myConf
  }

  lazy val conn = {
    //本地开启
    ConnectionFactory.createConnection(conf)
  }

  def getTable(tbName: String, ns: String = RT_NS) = {
    conn.getTable(TableName.valueOf(ns, tbName))
  }

  def getRowData(tb: Table, rowkey: String, family: String = FAMILY_NAME) = {
    var m = Map.empty[String, String]
    try {

      val g = new Get(Bytes.toBytes(rowkey))
      // val g = new Get(rowkey.getBytes)
      val r = tb.get(g).rawCells()
      m = r.map(c1 => (Bytes.toString(CellUtil.cloneQualifier(c1)), Bytes.toString(CellUtil.cloneValue(c1)))).toMap
    } catch {
      case e: Throwable => e.printStackTrace()
    }
    m
  }

  def main(args: Array[String]): Unit = {
    val row = getRowData(getTable("COMPANY_SCORE_V3"), "100008680_101")
    println(row)
  }
}
